#!/usr/bin/python

from os import popen as os_popen

pkg_feed = os_popen("grep 'Package: ' /var/lib/apt/lists/*_._Packages | awk '{print $2}'").read().split('\n')[:-1]

def dpkg_dump():
	pkg_installed = os_popen("dpkg -l | awk '{if ($1 == \"ii\") print $2}'").read().split('\n')[5:-1]
	# ugly fix!! blacklist = ['dreambox-dvb-modules-stb-', 'dreambox-dvb-modules-syst', 'enigma2-plugin-extensions', 'enigma2-plugin-systemplug', 'gst-plugins-base-audiocon', 'gst-plugins-base-audiores', 'gst-plugins-base-decodebi', 'gst-plugins-base-decodebi', 'gst-plugins-base-typefind', 'gst-plugins-good-audiopar', 'gst-plugins-good-autodete', 'gst-plugins-good-rtpmanag', 'gst-plugins-good-souphttp', 'gst-plugins-ugly-mpegaudi', 'gst-plugins-ugly-mpegstre', 'kernel-module-ipt-masquer', 'kernel-module-iptable-fil', 'kernel-module-nf-conntrac', 'kernel-module-nf-defrag-i', 'kernel-module-nls-iso8859', 'opendreambox-archive-keyr', 'packagegroup-opendreambox', 'qt4-embedded-plugin-image', 'qt4-embedded-plugin-sqldr']
	# ugly fix!! return [ i for i in pkg_installed if i not in pkg_feed + blacklist ]
	return [ i for i in pkg_installed if i not in pkg_feed ]

def opkg_dump():
	pkg_installed = os_popen("opkg list-installed | awk '{print $1}'").read().split('\n')[:-1]
	return [ i for i in pkg_installed if i not in pkg_feed ]

# main ---------------------------------------------------------------------------------------------------------------

if __name__ == '__main__':
	import sys
	import os.path as os_path
	name = os_path.basename(sys.argv[0])
	for x in sys.argv:
		print x
		if x == "dpkg":
			print dpkg_dump()
		if x == "opkg":
			print opkg_dump()
		if x.find(name):
			pass
		else:
			print "Usage: " + name + " dpkg, opkg"
			sys.exit(1)
		
	if len(sys.argv) == 1:
		print "Usage: " + name + " dpkg, opkg"
		sys.exit(1)
	sys.exit(0)
